//=============================  css  =============================//

var styles = new Array(), editor = null, id_editor = 'css_text', startpos = 0, endpos = 0, mouse_x = 0, mouse_y = 0;

//======================      =========================//
function init() {
    var ns4 = (document.layers)? true:false; //var ie4 = (document.all)? true:false;
    if (ns4) {document.captureEvents(Event.MOUSEMOVE);}
    document.onmousemove=mousemove;
}
function mousemove(event) {
    if (document.attachEvent != null) { mouse_x = window.event.clientX; mouse_y = window.event.clientY;}
    else
    if (!document.attachEvent && document.addEventListener) { mouse_x = event.clientX; mouse_y = event.clientY; }

    var html = document.documentElement, body = document.body;
    mouse_x += (html.scrollLeft || body && body.scrollLeft || 0); mouse_x -= html.clientLeft || 0;
    mouse_y += (html.scrollTop || body && body.scrollTop || 0);   mouse_y -= html.clientTop || 0;
}
        //         
function mouseXYtoLineChar(){
   var area = document.getElementById(id_editor),
   x = mouse_x - getElementPos(area).left + area.scrollLeft,
   y = mouse_y - getElementPos(area).top + area.scrollTop,
   line = Math.round(y/16)-1,
   char = Math.round(x/8)-1;
   return {line:line,char:char};
}
function getTextHelp(prop,txt){
   var result = '';
   if(prop==txt) result = getHelp(txt,styleProps); else
      {
       	if((prop=='border')||(prop=='border-top')||(prop=='border-left')||(prop=='border-right')||(prop=='border-bottom')
      	  ||(prop=='border-top-style')||(prop=='border-left-style')||(prop=='border-right-style')||(prop=='border-bottom-style'))
      	   result = getHelp(txt,border_style);
        if(prop=='text-align') result = getHelp(txt,text_align);
        if(prop=='text-decoration') result = getHelp(txt,text_decoration);
        if(prop=='text-transform') result = getHelp(txt,text_transform);
        if(prop=='float') result = getHelp(txt,float);
        if(prop=='clear') result = getHelp(txt,clear);
        if(prop=='position') result = getHelp(txt,position);
        if(prop=='cursor') result = getHelp(txt,cursor);
        if(prop=='display') result = getHelp(txt,display);
        if(prop=='visibility') result = getHelp(txt,visibility);
        if(prop=='overflow') result = getHelp(txt,overflow);
        if((prop=='box-sizing')||(prop=='-moz-box-sizing')||(prop=='-webkit-box-sizing')) result = getHelp(txt,box_sizing);
        if(prop=='resize') result = getHelp(txt,resize);
        if((prop=='background')||(prop=='background-repeat')) result = getHelp(txt,background_repeat);
        if((prop=='background')||(prop=='background-attachment')) result = getHelp(txt,background_attachment);
        if((prop=='background')||(prop=='background-position')) result = getHelp(txt,background_position);
        if(prop=='font-family') {result = getHelp(txt,font_family); if(result=='')result = ': ' + txt;}
        if(prop=='font-size') result = getHelp(txt,font_size);
        if(prop=='font-variant') result = getHelp(txt,font_variant);
        if(prop=='font-style') result = getHelp(txt,font_style);
        if(prop=='font-weight') result = getHelp(txt,font_weight);
        if(prop=='white-space') result = getHelp(txt,white_space);
        if(prop=='word-wrap') result = getHelp(txt,word_wrap);
        if(prop=='vertical-align') result = getHelp(txt,vertical_align);
        if(prop=='table-layout') result = getHelp(txt,table_layout);
        if(prop=='clip') result = getHelp(txt,clip);
        if(prop=='border-collapse') result = getHelp(txt,border_collapse);
        if((prop=='list-style')||(prop=='list-style-type')) result = getHelp(txt,list_style_type);
        if((prop=='list-style')||(prop=='list-style-position')) result = getHelp(txt,list_style_position);
        if(result==''){
              if((txt.charAt(0) == '#')||(color_nameToHex(txt)!=null)) result =  ': '+txt;
              var tmp = txt.substring(txt.length-1);
              if(getHelp(tmp,meter)!='') result =  getHelp(tmp,meter);
              if(result==''){ tmp = txt.substring(txt.length-2); if(getHelp(tmp,meter)!='') result =  getHelp(tmp,meter);}
              if(result=='') result =  txt;
              }
      }
   return result;
}
       //     
function getWord(){
   var area = document.getElementById(id_editor), result = '', ch = '',
   txt = area.value, arr =  txt.split('\n'),
   l = mouseXYtoLineChar().line, stpos = mouseXYtoLineChar().char, wpos, prop = '';
   if((l>=0)&&(ch>=0)&&(arr.length>l))
     {
      txt = arr[l];   prop = txt.split(':'); prop = trim(prop[0]);
      ch = txt.charAt(stpos); wpos = stpos; stpos--; result = ch;
      while((ch!=' ')&&(ch!=':')&&(ch!=';')&&(stpos>0)){ ch = txt.charAt(stpos); if((ch!=' ')&&(ch!=':')&&(ch!=';'))stpos--; else stpos++;}
      ch = result; wpos++;
      while((ch!=' ')&&(ch!=':')&&(ch!=';')&&(wpos<txt.length)){ ch = txt.charAt(wpos); if((ch!=' ')&&(ch!=':')&&(ch!=';'))wpos++;}
      result = txt.substring(stpos,wpos);
      result = trim(result);
      result = getTextHelp(prop,result);
     }
   if(result!='') document.getElementById('preview').innerHTML = result;  // area.title = result;
   return result;
}
        //       css 
function getPosToXY(){
   var area = document.getElementById(id_editor), lineHeigth = 16,
   x = getElementPos(area).left+32, y = 0, txt = '', b = 0;   // 4x8=32
     if ((area.selectionStart)||(area.selectionStart=='0')) {
         txt = area.value.substring(0,area.selectionEnd);
         }
     if (document.selection) {
         sel=document.selection.createRange();
         var clone=sel.duplicate();
         sel.collapse(true);
         clone.moveToElementText(area);
         clone.setEndPoint('EndToEnd',sel);
         txt = clone.text; b = 1;
         }
  var lineNum = occur(txt,'\n') + b;
  y = getElementPos(area).top + lineNum*lineHeigth - area.scrollTop;
  return {X:Math.round(x),Y:Math.round(y)};
}

function setFilename(name){
    document.getElementById('css_name').innerHTML = name;
  	download.filename.value = name;
}

function openCss(name,value) {
  	document.getElementById(id_editor).value = value;
  	setFilename(name);
  	format_css_text();
}

function createUploadBtn(imgUrl,mode,title){
return "<div style='overflow:hidden; width:48px;height:16px;background:url("+imgUrl+") no-repeat; float:left;'>"+
       "<form action=upload.php target=loader name=upload enctype='multipart/form-data' method=post style='padding:0px;margin:0px'>"+
       "<input type=hidden name=mode value='"+mode+"'>"+
       "<input type=file name="+mode+"file size=1 onchange='upload.submit();' style='cursor:pointer;opacity:0;filter:alpha(opacity:0);' title='"+title+"'>"+
       "</form></div>&nbsp;";
}
        //  
function createCssEditor(css,w,x,y){
   init(); if(!x) x = mouse_x; if(!y) y = mouse_y; var name = 'styleName.css';
   if(css=="") css = "/* */\n.newStyle {\n}"; else {name = css;  css = file_get_contents(css); }
   var txt = "<div align=center style='height:100px;'>"+
             "<div id=css_name style='background-color:#F9E9BD;border-bottom:1px solid orange;'>"+name+"</div>"+
             "<div id=preview> </div></div>"+
             "<div style='background-color:#F9E9BD;border-top:1px solid orange;padding-top:7px;'>"+
             createUploadBtn('data/open.png','css','  css   ')+
             "<img style='cursor: pointer;' src='data/edit.png' border=0 onclick='format_css_text();' title=''>&nbsp;"+
             "<img style='cursor: pointer;' src='data/save16.png' border=0 onclick='hideProps();download.submit();' title='  css   '>&nbsp;"+
             "<img style='cursor: pointer;' src='data/box_close16.png' border=0 onclick='hideProps();document.body.removeChild(editor);' title=''>"+
             "</div>"+
             "<form name=download target=loader enctype='multipart/form-data' action=download.php method=post style='margin:0px'>"+
             "<textarea id="+id_editor+" name="+id_editor+" spellcheck=false wrap=off "+
             "style='resize:none;color:green;padding:0px;border:1px none orange;border-top-style:solid;' "+
             "onpaste='format();' "+
             "onmousemove='getWord();' "+
             "onkeyup='evt = window.event||event; newstr(evt);' "+
             "onclick='hideProps();' "+
             "onscroll='hideProps();' "+
             "ondblclick='get_sel_text();'>"+css+"</textarea>"+
             "<input type=hidden name=id_editor value="+id_editor+">"+
             "<input type=hidden name=filename value='style.css'></form>"+
             "<iframe id=loader name=loader src='about:blank' style='width:0px;height:0px;border:0px'></iframe>";
   if(!editor)  {
       editor = document.createElement('DIV');
       editor.style.display = 'block';
       editor.style.position	= 'absolute';
       editor.style.overflow = 'hidden';
       editor.id = 'editor_block';
       editor.style.fontFamily = 'monospace';
       editor.style.fontSize = '10pt';
       editor.style.border = '1px solid orange';
       editor.innerHTML = txt;
       document.body.appendChild(editor);
      }
   var area = document.getElementById(id_editor);
   area.style.width = w + 'em';  area.style.height = w*0.5 + 'em';
   editor.style.top  = y + 'px'; editor.style.left = x + 'px';  editor.style.width = w +'em';
   startpos=css.length - 2; SelectText();
}

//===============================     ================================//
        //   css  (url  !)
function file_get_contents( url ) {
	var req = null;
	try { req = new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {
		try { req = new ActiveXObject("Microsoft.XMLHTTP"); } catch (e) {
			try { req = new XMLHttpRequest(); } catch(e) {}
		}
	}
	if (req == null) throw new Error('XMLHttpRequest not supported');
	req.open("GET", url, false);  req.send(null);
	if (req.status == 200) return req.responseText; else return '';
}
        //   
function get_css_styleComment(str){
   var k1 = str.lastIndexOf('/*'), k2 = str.lastIndexOf('*/'), txt = '';
   if((k1 != -1)&&(k2 != -1)&&(k2>k1)) txt = str.substring(k1+2, k2);
   if(trim(txt)=='')txt = ' ';
   return txt;
}
        //   
function get_css_styleValue(str){
   var k1 = str.indexOf('{'), k2 = str.indexOf('}'), txt = str.substring(k1+1, k2);
   txt = txt.replace(/\r\n|\r|\n/g,'');
   return trim(txt);
}
        //     preview
function set_css_stylePreview(){
    if(document.getElementById('preview'))
    {
        var preview = document.getElementById('preview'), area = document.getElementById(id_editor), stpos = startpos, st = area.value.substring(stpos);
        if (document.selection){ st = area.value.substring(0,stpos); stpos += occur(st,'\n'); st = area.value.substring(stpos); }
        var k1 = st.indexOf('}'), k2 = st.indexOf('{');
        if((k1 < k2)||(k1==-1)||(k2==-1)){ st = area.value.substring(0,stpos); k2 = st.lastIndexOf('{'); st = area.value.substring(k2);}
        if((k1!=-1)&&(k2!=-1)&&(st!='')){
        st = get_css_styleValue(st);
        preview.style.cssText = st;
        st = area.value.substring(0,stpos+3); //alert(st);
        preview.innerHTML = get_css_styleComment(st); }
    }
}
        //      styles  txt  textarea (id_editor)
function get_css_styles(txt){
 var i = 0, k1 = 0, k2 = 0, st = '';
 if((!txt)&&(document.getElementById(id_editor))) txt = document.getElementById(id_editor).value;
   txt = txt.replace(/\r\n|\r|\n/g,'');
   while (k2 != -1)
     {
      k2 = txt.indexOf('}',k1);
      if(k2!=-1)
        {
         styles[i] = txt.substring(k1, k2+1);
         k1 = k2+1;
         i++;
        }
     }
}
        //    
function format_css_styles(text){
   get_css_styles(text); hideProps();
   var cnt = styles.length, i = 0, k1, k2, str, txt = '';
   while (i < cnt)
     {
      str = styles[i];
      k2 = str.indexOf('/*');      k1 = str.indexOf('*/');
      if((k2 != -1)&&(k1 != -1)) {k1 = k1 + 2; txt += str.substring(k2, k1)+'\n';  } // 
      else  k1 = 0;
      k2 = str.indexOf('{');
      txt += str.substring(k1, k2+1)+'\n';//  
      k1 = k2+1;
      while (k2 != -1)    //   
        {
         k2 = str.indexOf(';',k1);
         if(k2!=-1)
           {
            txt += '    '+trim(str.substring(k1, k2+1))+'\n';
            k1 = k2+1;
           }
        }
      txt += '}\n';
      i++;
     }
   return txt;
}

function format(){setTimeout('format_css_text()', 1000);}

function format_css_text(){ document.getElementById(id_editor).value = format_css_styles(); }

//============================= palette ==============================//
function decToHex(decArray) {
	var hex = ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F']; var out = "#";
	for (var i = 0; i < decArray.length; i++) { dec = parseInt(decArray[i]); out += hex[parseInt(dec / 16)] + hex[dec % 16]; }
	return out; }

function hslToHex(H, S, L) {
    var H,S,L,Q,P,Hk; T=[]; C=[];
    if (L<1/2) { Q=L*(1+S); } else { Q=L+S-L*S; }
    P=2*L-Q; Hk=H/360; T[0]=Hk+1/3; T[1]=Hk; T[2]=Hk-1/3;
    for(i=0;i<3;i++) { if (T[i]<0) { T[i]+=1 } else if (T[i]>1) { T[i]-=1; } }
    for(i=0;i<3;i++) { if (T[i]<1/6) { C[i]=P+((Q-P)*6*T[i]); } else if (T[i]<1/2 && T[i]>=1/6) { C[i]=Q; }
      else if (T[i]>=1/2 && T[i]<2/3) { C[i]=P+((Q-P)*(2/3-T[i])*6); } else C[i]=P; }
    for(i=0;i<3;i++) { C[i]*=255; }
    return decToHex(C); }

function rgbToHex(r, g, b) {
    var r = r.toString(16), g = g.toString(16), b = b.toString(16);
    if (r.length == 1) r = '0' + r; if (g.length == 1) g = '0' + g; if (b.length == 1) b = '0' + b;
    return '#'+(r + g + b).toUpperCase();  }

function hexToRgb(hex) {
    if (hex.substr(0, 1) == '#') hex = hex.substr(1); var r, g, b;
    r = hex.substr(0, 2); r = parseInt(r, 16); g = hex.substr(2, 2); g = parseInt(g, 16); b = hex.substr(4, 2); b = parseInt(b, 16);
    return {r: r, g: g, b: b};  }
                                     //     
function paletteClick(color) {
    insert_txt_area(color);
    document.getElementById("palette").style.display = "none";
    document.getElementById("cur").style.display = "none"; }

function paletteMove(color) {        //    
    if(document.getElementById("picker")){
    var picker = document.getElementById("picker"), r=hexToRgb(color).r, g=hexToRgb(color).g, b=hexToRgb(color).b;
    var name = hexToColor_name(color); if(name==null)name = "";
    picker.innerHTML = "rgb("+r+", "+g+", "+b+")&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+color+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+name;
    picker.style.background = color;
	if((((r+g+b)/3)>160)||(r==255)||(g==255)){r=0;g=0;b=0} else {r=255;g=255;b=255}
	picker.style.color = rgbToHex(r, g, b);}
	if(document.getElementById("cur")){document.getElementById("cur").style.left = mouse_x + "px";
	document.getElementById("cur").style.color = picker.style.color; }}

function createPalette(txt) {        //     div
  var palette, cur;
  if(document.getElementById("palette")) palette = document.getElementById("palette"); else
    {
     var color, colItems = "", k = 0;
     palette = document.createElement("DIV");
     palette.style.display = "none";
     palette.style.cursor 	= "crosshair";
     palette.style.position	= "absolute";
     palette.id = 'palette';
     document.body.appendChild(palette);
     for(var i=0;i<256;i++) {   //    i=i+4
       color = rgbToHex(i,i,i); k++;
       colItems += "<DIV style='float:left; width:1px; height:32px; background:"+color+
       "' onclick='paletteClick(\""+color+"\");' onmousemove='paletteMove(\""+color+"\");'></DIV>"; }
     for(var i=0;i<360;i++) {   //    i=i+2
	   color = hslToHex(i,1,0.5); k++;
	   colItems += "<DIV style='float:left; width:1px; height:32px; background:"+color+
	   "' onclick='paletteClick(\""+color+"\");' onmousemove='paletteMove(\""+color+"\");'></DIV>"; }
     palette.innerHTML = "<DIV id='picker' style='width:"+k+"px; height:15px; text-align:center; font-size:11px;'></DIV>"+colItems;
   }
  if(document.getElementById("cur")) cur = document.getElementById("cur"); else //    
    {
     cur = document.createElement("DIV");
     cur.style.display = "none";
     cur.style.position	= "absolute"; cur.id = 'cur';
     cur.style.fontSize = '8px'; cur.style.zIndex = 2; cur.innerHTML = "|";
     document.body.appendChild(cur);
    }
  cur.style.display = "block";
  cur.style.top  = (mouse_y + 12) + "px";
  paletteMove(txt);
  palette.style.top  = mouse_y + "px";
  palette.style.left = mouse_x + "px";
  palette.style.display = "block";
}

function color_nameToHex(name){return {"aliceblue":"#f0f8ff","antiquewhite":"#faebd7","aqua":"#00ffff","aquamarine":"#7fffd4","azure":"#f0ffff","beige":"#f5f5dc","bisque":"#ffe4c4","black":"#000000","blanchedalmond":"#ffebcd","blue":"#0000ff","blueviolet":"#8a2be2","brown":"#a52a2a","burlywood":"#deb887","cadetblue":"#5f9ea0","chartreuse":"#7fff00","chocolate":"#d2691e","coral":"#ff7f50","cornflowerblue":"#6495ed","cornsilk":"#fff8dc","crimson":"#dc143c","cyan":"#00ffff","darkblue":"#00008b","darkcyan":"#008b8b","darkgoldenrod":"#b8860b","darkgray":"#a9a9a9","darkgreen":"#006400","darkkhaki":"#bdb76b","darkmagenta":"#8b008b","darkolivegreen":"#556b2f","darkorange":"#ff8c00","darkorchid":"#9932cc","darkred":"#8b0000","darksalmon":"#e9967a","darkseagreen":"#8fbc8f","darkslateblue":"#483d8b","darkslategray":"#2f4f4f","darkturquoise":"#00ced1","darkviolet":"#9400d3","deeppink":"#ff1493","deepskyblue":"#00bfff","dimgray":"#696969","dodgerblue":"#1e90ff","feldspar":"#d19275","firebrick":"#b22222","floralwhite":"#fffaf0","forestgreen":"#228b22","fuchsia":"#ff00ff","gainsboro":"#dcdcdc","ghostwhite":"#f8f8ff","gold":"#ffd700","goldenrod":"#daa520","gray":"#808080","green":"#008000","greenyellow":"#adff2f","honeydew":"#f0fff0","hotpink":"#ff69b4","indianred":"#cd5c5c","indigo":"#4b0082","ivory":"#fffff0","khaki":"#f0e68c","lavender":"#e6e6fa","lavenderblush":"#fff0f5","lawngreen":"#7cfc00","lemonchiffon":"#fffacd","lightblue":"#add8e6","lightcoral":"#f08080","lightcyan":"#e0ffff","lightgoldenrodyellow":"#fafad2","lightgrey":"#d3d3d3","lightgreen":"#90ee90","lightpink":"#ffb6c1","lightsalmon":"#ffa07a","lightseagreen":"#20b2aa","lightskyblue":"#87cefa","lightslateblue":"#8470ff","lightslategray":"#778899","lightsteelblue":"#b0c4de","lightyellow":"#ffffe0","lime":"#00ff00","limegreen":"#32cd32","linen":"#faf0e6","magenta":"#ff00ff","maroon":"#800000","mediumaquamarine":"#66cdaa","mediumblue":"#0000cd","mediumorchid":"#ba55d3","mediumpurple":"#9370d8","mediumseagreen":"#3cb371","mediumslateblue":"#7b68ee","mediumspringgreen":"#00fa9a","mediumturquoise":"#48d1cc","mediumvioletred":"#c71585","midnightblue":"#191970","mintcream":"#f5fffa","mistyrose":"#ffe4e1","moccasin":"#ffe4b5","navajowhite":"#ffdead","navy":"#000080","oldlace":"#fdf5e6","olive":"#808000","olivedrab":"#6b8e23","orange":"#ffa500","orangered":"#ff4500","orchid":"#da70d6","palegoldenrod":"#eee8aa","palegreen":"#98fb98","paleturquoise":"#afeeee","palevioletred":"#d87093","papayawhip":"#ffefd5","peachpuff":"#ffdab9","peru":"#cd853f","pink":"#ffc0cb","plum":"#dda0dd","powderblue":"#b0e0e6","purple":"#800080","red":"#ff0000","rosybrown":"#bc8f8f","royalblue":"#4169e1","saddlebrown":"#8b4513","salmon":"#fa8072","sandybrown":"#f4a460","seagreen":"#2e8b57","seashell":"#fff5ee","sienna":"#a0522d","silver":"#c0c0c0","skyblue":"#87ceeb","slateblue":"#6a5acd","slategray":"#708090","snow":"#fffafa","springgreen":"#00ff7f","steelblue":"#4682b4","tan":"#d2b48c","teal":"#008080","thistle":"#d8bfd8","tomato":"#ff6347","turquoise":"#40e0d0","violet":"#ee82ee","violetred":"#d02090","wheat":"#f5deb3","white":"#ffffff","whitesmoke":"#f5f5f5","yellow":"#ffff00","yellowgreen":"#9acd32"}[name.toLowerCase()]||null;}
function hexToColor_name(hex){return {"#f0f8ff":"aliceblue","#faebd7":"antiquewhite","#00ffff":"aqua","#7fffd4":"aquamarine","#f0ffff":"azure","#f5f5dc":"beige","#ffe4c4":"bisque","#000000":"black","#ffebcd":"blanchedalmond","#0000ff":"blue","#8a2be2":"blueviolet","#a52a2a":"brown","#deb887":"burlywood","#5f9ea0":"cadetblue","#7fff00":"chartreuse","#d2691e":"chocolate","#ff7f50":"coral","#6495ed":"cornflowerblue","#fff8dc":"cornsilk","#dc143c":"crimson","#00ffff":"cyan","#00008b":"darkblue","#008b8b":"darkcyan","#b8860b":"darkgoldenrod","#a9a9a9":"darkgray","#006400":"darkgreen","#bdb76b":"darkkhaki","#8b008b":"darkmagenta","#556b2f":"darkolivegreen","#ff8c00":"darkorange","#9932cc":"darkorchid","#8b0000":"darkred","#e9967a":"darksalmon","#8fbc8f":"darkseagreen","#483d8b":"darkslateblue","#2f4f4f":"darkslategray","#00ced1":"darkturquoise","#9400d3":"darkviolet","#ff1493":"deeppink","#00bfff":"deepskyblue","#696969":"dimgray","#1e90ff":"dodgerblue","#d19275":"feldspar","#b22222":"firebrick","#fffaf0":"floralwhite","#228b22":"forestgreen","#ff00ff":"fuchsia","#dcdcdc":"gainsboro","#f8f8ff":"ghostwhite","#ffd700":"gold","#daa520":"goldenrod","#808080":"gray","#008000":"green","#adff2f":"greenyellow","#f0fff0":"honeydew","#ff69b4":"hotpink","#cd5c5c":"indianred","#4b0082":"indigo","#fffff0":"ivory","#f0e68c":"khaki","#e6e6fa":"lavender","#fff0f5":"lavenderblush","#7cfc00":"lawngreen","#fffacd":"lemonchiffon","#add8e6":"lightblue","#f08080":"lightcoral","#e0ffff":"lightcyan","#fafad2":"lightgoldenrodyellow","#d3d3d3":"lightgrey","#90ee90":"lightgreen","#ffb6c1":"lightpink","#ffa07a":"lightsalmon","#20b2aa":"lightseagreen","#87cefa":"lightskyblue","#8470ff":"lightslateblue","#778899":"lightslategray","#b0c4de":"lightsteelblue","#ffffe0":"lightyellow","#00ff00":"lime","#32cd32":"limegreen","#faf0e6":"linen","#ff00ff":"magenta","#800000":"maroon","#66cdaa":"mediumaquamarine","#0000cd":"mediumblue","#ba55d3":"mediumorchid","#9370d8":"mediumpurple","#3cb371":"mediumseagreen","#7b68ee":"mediumslateblue","#00fa9a":"mediumspringgreen","#48d1cc":"mediumturquoise","#c71585":"mediumvioletred","#191970":"midnightblue","#f5fffa":"mintcream","#ffe4e1":"mistyrose","#ffe4b5":"moccasin","#ffdead":"navajowhite","#000080":"navy","#fdf5e6":"oldlace","#808000":"olive","#6b8e23":"olivedrab","#ffa500":"orange","#ff4500":"orangered","#da70d6":"orchid","#eee8aa":"palegoldenrod","#98fb98":"palegreen","#afeeee":"paleturquoise","#d87093":"palevioletred","#ffefd5":"papayawhip","#ffdab9":"peachpuff","#cd853f":"peru","#ffc0cb":"pink","#dda0dd":"plum","#b0e0e6":"powderblue","#800080":"purple","#ff0000":"red","#bc8f8f":"rosybrown","#4169e1":"royalblue","#8b4513":"saddlebrown","#fa8072":"salmon","#f4a460":"sandybrown","#2e8b57":"seagreen","#fff5ee":"seashell","#a0522d":"sienna","#c0c0c0":"silver","#87ceeb":"skyblue","#6a5acd":"slateblue","#708090":"slategray","#fffafa":"snow","#00ff7f":"springgreen","#4682b4":"steelblue","#d2b48c":"tan","#008080":"teal","#d8bfd8":"thistle","#ff6347":"tomato","#40e0d0":"turquoise","#ee82ee":"violet","#d02090":"violetred","#f5deb3":"wheat","#ffffff":"white","#f5f5f5":"whitesmoke","#ffff00":"yellow","#9acd32":"yellowgreen"}[hex.toLowerCase()]||null;}
function checkHexColor(txt){ var pattern = /^#?([a-f]|[A-F]|[0-9]){3}(([a-f]|[A-F]|[0-9]){3})?$/; return pattern.test(txt); }
//==============================================================================//

        //      
function trim( str, charlist ) {
    charlist = !charlist ? ' \\s\xA0' : charlist.replace(/([\[\]\(\)\.\?\/\*\{\}\+\$\^\:])/g, '\$1');
    var re = new RegExp('^[' + charlist + ']+|[' + charlist + ']+$', 'g');
    return str.replace(re, '');
}
	    //   substr  str
function occur(str, substr) {
  var pos = str.indexOf(substr);
  for (var count = 0; pos != -1; count++)pos = str.indexOf(substr, pos + substr.length);
  return count;
}
        //     el
function getElementPos(el)
{ var l = 0, t = 0, elem=el;
 while (elem) { l += elem.offsetLeft; t += elem.offsetTop; elem = elem.offsetParent; }
 return {"left":l, "top":t};
}
        //     css   
function hideProps(){
	if(document.getElementById("props")) document.getElementById("props").style.display="none";
    if(document.getElementById("palette")) document.getElementById("palette").style.display="none";
    if(document.getElementById("cur")) document.getElementById("cur").style.display="none";
 }
        //      enter      css       
function newstr(evt) {
  var key = evt.keyCode || evt.which;
  if(key === 13){
     var x = getPosToXY().X; var y = getPosToXY().Y,ch = '', stpos=0; area = document.getElementById(id_editor); area.focus();

     if ((area.selectionStart)||(area.selectionStart=='0')) { startpos = area.selectionStart;
         area.value=area.value.substring(0,startpos)+'    '+area.value.substring(startpos,area.value.length);
         startpos = startpos + 4;
         endpos = startpos; area.setSelectionRange(startpos,endpos); area.focus(); stpos = startpos;}
     if (document.selection) { var sel=document.selection.createRange(); sel.text='    ';
         var clone=sel.duplicate(); sel.collapse(true); clone.moveToElementText(area);
         clone.setEndPoint('EndToEnd',sel); startpos = clone.text.length - occur(clone.text,'\n');
         endpos = 0; sel.select(); stpos = clone.text.length;}
     ch = trim(area.value.substring(0,stpos)); ch = ch.charAt(ch.length - 1);
     if((ch==';')||(ch=='{')) createProps('',styleProps,200,x,y);
     else {
     	 if(ch=='}')
     	    { stpos = stpos - 4; endpos = stpos;
             area.value=area.value.substring(0,stpos)+'.newStyle {\n}'+area.value.substring(stpos,area.value.length);}
             startpos = startpos - 4 + 11; endpos = 0;
             SelectText();
          }
    }
}
        //        arr   
function createProps(txt,arr,w,x,y){
   var str='', tmp='',prop, props; if(!x) x = mouse_x; if(!y) y = mouse_y;
   if(document.getElementById("props")) props = document.getElementById("props"); else
      {
       props = document.createElement("DIV");
       props.style.display = "none";
       props.style.position	= "absolute";
       document.body.appendChild(props);
      }
tmp = txt.split(':'); prop = trim(tmp[0]);
var menu = "<SELECT onchange='insert_txt_area(this.value); hideProps();' style='padding:0px;'>";
if(prop=='') menu += "<OPTION selected VALUE='' title='   '> </option>";
for (var i = 0; i < arr.length; i++) {
     str = arr[i].split('|');
     tmp = str[0]; tmp = tmp.split(':'); if(tmp!=str[0])tmp = tmp[0];
     if((prop!='')&&(tmp==prop)) menu += "<OPTION selected VALUE='"+str[0]+"' title='"+str[1]+"'>"+tmp+"</option>"; else
     menu += "<OPTION VALUE='"+str[0]+"' title='"+str[1]+"'>"+tmp+"</option>"; }
menu += "</SELECT>";
   props.style.display = "block";
   props.style.top  = y + "px";
   props.style.left = x + "px";
   props.style.width = w + "px";
   props.id = "props";
   props.innerHTML = menu; //alert(menu);
}
        //     
function getProp(i){
     var area = document.getElementById(id_editor),txt,tmp,k;
     if (area.selectionStart) k = area.selectionStart;
     if (document.selection) {
         var sel=document.selection.createRange(), clone=sel.duplicate(); sel.collapse(true);
         clone.moveToElementText(area);clone.setEndPoint('EndToEnd',sel);k = clone.text.length; }
     txt = area.value.substring(0,k);
     k = txt.lastIndexOf('{'); if(k!=-1) txt = txt.substring(k+1);
     k = txt.lastIndexOf(';'); if(k!=-1) txt = txt.substring(k+1);
     tmp = txt.split(':'); tmp[0] = trim(tmp[0]);
     return tmp[i];
}
        //       prop   arr
function getHelp(txt,arr){  var str, tmp, prop, help='';
   tmp = txt.split(':'); prop = trim(tmp[0]);
   for (var i = 0; i < arr.length; i++) {
   str = arr[i].split('|'); // =>  ["a","b","c"]
   tmp = str[0]; tmp = tmp.split(':'); if(tmp!=str[0]) tmp = tmp[0];
   if(tmp==prop) help = str[1]; }
   return help;
}
        //   csstext,     
function get_sel_csstext_area(){
     var txt = '',ch = '', k=0, prop = getProp(0), family=(prop=='font-family');
     var area = document.getElementById(id_editor);
     if ((area.selectionStart)||(area.selectionStart=='0')) {
         startpos = area.selectionStart;  endpos = area.selectionEnd;
         txt = area.value.substring(startpos,endpos); k = txt.indexOf(':');
         if(k!=-1) {startpos = startpos + k + 1; txt = area.value.substring(startpos,endpos);  }   // alert(txt);
         k = 0; ch = area.value.charAt(startpos-1);

         if(((ch=='#')||(ch=='-'))&&(!family))
         {
           startpos--;
           if(ch=='-')  while((ch != ' ')&&(ch!=':')&&(ch!=';')&&(ch!='{')) {
                            ch = area.value.charAt(startpos-1); if((ch != ' ')&&(ch!=':')&&(ch!=';')&&(ch!='{'))startpos--;}
         }
         else
         {
          ch = area.value.charAt(endpos-1);
          if(ch==' ')endpos--;
          txt = trim(txt);
          if((prop!='')&&(prop!='font-size'))
            {
       	     ch = txt.substring(txt.length-2);  k = txt.indexOf(ch);
             if(getHelp(ch,meter)!='') {startpos = startpos + k; }
             else { ch = txt.charAt(txt.length-1); k = txt.indexOf(ch); if(getHelp(ch,meter)!='') {startpos = startpos + k; }}
            }
         }

          txt = area.value.substring(startpos,endpos);
          area.setSelectionRange(startpos,endpos); area.focus();

          if(getProp(0)=='')
             {
              ch = area.value.charAt(endpos-1); k=0;
         	  while ((ch != ';')&&(k==0)&&(endpos < area.value.length)) {
         	  endpos++;
         	  ch = area.value.charAt(endpos-1);
              txt = area.value.substring(startpos,endpos);
              k = occur(txt,'\n'); if(k>0)endpos--;}
             }
              else
             {
              if(family)
                 {
                  k = getProp(1).length;
                  startpos=startpos-k; k=0;
                  ch = area.value.charAt(endpos-1);
         	      while ((ch != ';')&&(k==0)&&(endpos < area.value.length))
         	        {
         		     endpos++; ch = area.value.charAt(endpos-1);
                     txt = area.value.substring(startpos,endpos);
                     k = occur(txt,'\n');
                    }
         	      if(k>0)endpos--; if(ch==';')endpos--;
              	 }
              	  else
              	 {
                  ch = area.value.charAt(endpos-1);
                  while ((ch != ',')&&(ch != ';')&&(ch != ' ')&&(ch != ')')&&(endpos < area.value.length)) {endpos++; ch = area.value.charAt(endpos-1);}
                  if ((ch == ',')||(ch == ';')||(ch == ' ')||(ch == ')')) endpos--;
                 }
             }
         txt = area.value.substring(startpos,endpos);
         area.setSelectionRange(startpos,endpos); area.focus();
         }
     if (document.selection) {
         sel=document.selection.createRange(); txt = sel.text; endpos = txt.length;
         var clone=sel.duplicate(); sel.collapse(true);
         clone.moveToElementText(area);  clone.setEndPoint('EndToEnd',sel);
         startpos = clone.text.length - occur(clone.text,'\n');
         ch = clone.text.charAt(clone.text.length-1);

      	 if(((ch=='#')||(ch=='-'))&&(!family))
      	 {
       	   startpos--; sel.move("character", -1);
       	   if(txt.charAt(txt.length-1) != ' ') endpos++;
       	   k++;
       	   if(ch=='-')  while((ch != ' ')&&(ch!=':')&&(ch!=';')&&(ch!='{')) {
       	              k++; ch = clone.text.charAt(clone.text.length-k);
       	              if((ch!=' ')&&(ch!=':')&&(ch!=';')&&(ch!='{')) {sel.move("character", -1);endpos++; startpos --;}
       	              }
      	 }
      	 else
      	 {
       	  if(txt.charAt(txt.length-1) == ' ')endpos--;
       	  txt = trim(txt);
       	  if((prop!='')&&(prop!='font-size'))
       	     {
       	      ch = txt.substring(txt.length-1);  k = txt.indexOf(ch);
              if(getHelp(ch,meter)!='') {startpos = startpos + k; endpos = 1;sel.move("character", k);}
              else
              if(txt.length>2 ){ ch = txt.substring(txt.length-2); k = txt.indexOf(ch);
                if(getHelp(ch,meter)!='') {startpos = startpos + k; endpos = 2;sel.move("character", k);}}
             }
      	 }

         sel.moveEnd("character", endpos); sel.select(); //alert(txt);
         if(getProp(0)=='')
             {
              k=0; ch = sel.text.charAt(sel.text.length-1); //alert(txt);
         	  while ((ch != ';')&&(k==0)) {sel.moveEnd("character", 1); ch = sel.text.charAt(sel.text.length-1); k = occur(sel.text,'\n');}
         	  if(k>0)sel.moveEnd("character", -1);
         	 }
              else
             {
              if(family)
                {
                 k = getProp(1).length;
                 startpos=startpos-k; sel.move("character", -k);
                 ch = sel.text.charAt(sel.text.length-1); k=0;
         	     while ((ch != ';')&&(k==0)) {sel.moveEnd("character", 1); ch = sel.text.charAt(sel.text.length-1); k = occur(sel.text,'\n');}
         	     if(k>0)sel.moveEnd("character", -1); if(ch==';')sel.moveEnd("character", -1);
              	}
                 else
              	{
         	     ch = sel.text.charAt(sel.text.length-1);
         	     while ((ch != ',')&&(ch != ';')&&(ch != ' ')&&(ch != ')')) {sel.moveEnd("character", 1); ch = sel.text.charAt(sel.text.length-1);}
                 if ((ch == ',')||(ch == ';')||(ch == ' ')||(ch == ')')) sel.moveEnd("character", -1);
                }
             }
         txt = sel.text; endpos = txt.length;
         sel.select();
         }
     ch = getHelp(txt,styleProps); if(ch!='') area.title = ch; else area.title = hint;
     return trim(txt);
}
        //     id_editor,        
function get_sel_text(){
     var    txt = get_sel_csstext_area(), prop = getProp(0), w = 100;
     set_css_stylePreview();
     if((prop == '')&&(getHelp(txt,styleProps)!=''))createProps(txt,styleProps,200); else
      {
       	if(((prop=='border')||(prop=='border-top')||(prop=='border-left')||(prop=='border-right')||(prop=='border-bottom')
      	  ||(prop=='border-top-style')||(prop=='border-left-style')||(prop=='border-right-style')||(prop=='border-bottom-style'))
      	   &&(getHelp(txt,border_style)!='')) createProps(txt,border_style,w);
        if((prop=='text-align')&&(getHelp(txt,text_align)!='')) createProps(txt,text_align,w);
        if((prop=='text-decoration')&&(getHelp(txt,text_decoration)!='')) createProps(txt,text_decoration,w);
        if((prop=='text-transform')&&(getHelp(txt,text_transform)!='')) createProps(txt,text_transform,w);
        if((prop=='float')&&(getHelp(txt,float)!='')) createProps(txt,float,w);
        if((prop=='clear')&&(getHelp(txt,clear)!='')) createProps(txt,clear,w);
        if((prop=='position')&&(getHelp(txt,position)!='')) createProps(txt,position,w);
        if((prop=='cursor')&&(getHelp(txt,cursor)!='')) createProps(txt,cursor,w);
        if((prop=='display')&&(getHelp(txt,display)!='')) createProps(txt,display,w);
        if((prop=='visibility')&&(getHelp(txt,visibility)!='')) createProps(txt,visibility,w);
        if((prop=='overflow')&&(getHelp(txt,overflow)!='')) createProps(txt,overflow,w);
        if(((prop=='box-sizing')||(prop=='-moz-box-sizing')||(prop=='-webkit-box-sizing'))&&(getHelp(txt,box_sizing)!='')) createProps(txt,box_sizing,w);
        if((prop=='resize')&&(getHelp(txt,resize)!='')) createProps(txt,resize,w);
        if(((prop=='background')||(prop=='background-repeat'))&&(getHelp(txt,background_repeat)!='')) createProps(txt,background_repeat,w);
        if(((prop=='background')||(prop=='background-attachment'))&&(getHelp(txt,background_attachment)!='')) createProps(txt,background_attachment,w);
        if(((prop=='background')||(prop=='background-position'))&&(getHelp(txt,background_position)!='')) createProps(txt,background_position,w);
        if(prop=='font-family') {if(getHelp(txt,font_family)!='') createProps(txt,font_family,400); else createProps('',font_family,400); }
        if((prop=='font-variant')&&(getHelp(txt,font_variant)!='')) createProps(txt,font_variant,w);
        if((prop=='font-style')&&(getHelp(txt,font_style)!='')) createProps(txt,font_style,w);
        if((prop=='font-weight')&&(getHelp(txt,font_weight)!='')) createProps(txt,font_weight,w);
        if(prop=='font-size') createProps(txt,font_size,w);
        if((prop=='white-space')&&(getHelp(txt,white_space)!='')) createProps(txt,white_space,w);
        if((prop=='word-wrap')&&(getHelp(txt,word_wrap)!='')) createProps(txt,word_wrap,w);
        if((prop=='vertical-align')&&(getHelp(txt,vertical_align)!='')) createProps(txt,vertical_align,w);
        if((prop=='table-layout')&&(getHelp(txt,table_layout)!='')) createProps(txt,table_layout,w);
        if((prop=='clip')&&(getHelp(txt,clip)!='')) createProps(txt,clip,w);
        if((prop=='border-collapse')&&(getHelp(txt,border_collapse)!='')) createProps(txt,border_collapse,w);
        if(((prop=='list-style')||(prop=='list-style-type'))&&(getHelp(txt,list_style_type)!='')) createProps(txt,list_style_type,w);
        if(((prop=='list-style')||(prop=='list-style-position'))&&(getHelp(txt,list_style_position)!='')) createProps(txt,list_style_position,w);

        if(getHelp(txt,meter)!='')createProps(txt,meter,w);
        else { if(txt.charAt(0) != '#') txt = color_nameToHex(txt);
            if((txt != null)&&(checkHexColor(txt))) createPalette(txt); }
      }
}
        //      
function SelectText() {
    var area = document.getElementById(id_editor);  area.focus();
    if ((area.selectionStart)||(area.selectionStart=='0')) { if(endpos<startpos)endpos=startpos; area.setSelectionRange(startpos,endpos); area.focus(); }
    if (document.selection){
    var sel=document.selection.createRange(); sel.moveToElementText(area);
    sel.move("character", startpos); sel.moveEnd("character", endpos); sel.select(); }
}
        //      
function insert_txt_area(txt){
      if(startpos!=0)
      {
        var area = document.getElementById(id_editor);
        if ((area.selectionStart)||(area.selectionStart=='0'))  {
        area.value=area.value.substring(0,startpos)+txt+area.value.substring(endpos,area.value.length);
        endpos = startpos + txt.length;
        area.setSelectionRange(startpos,endpos); area.focus(); }
        if (document.selection) {
        SelectText();
     	sel=document.selection.createRange(); sel.text=txt;
     	endpos = txt.length;
        sel.move("character", -endpos); sel.moveEnd("character", endpos);
        sel.select(); }
        set_css_stylePreview();
     }
}
